
CoCoALib - Design #1124

Move examples directory into doc -- or just change makefile?

16 Nov 2017 15:22 - John Abbott

Status: Closed Start date: 16 Nov 2017

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Documentation Estimated time: 5.01 hours

Target version: CoCoALib-0.99600 Spent time: 5.10 hours

Description

After having improved the installation procedure for CoCoALib, it seems better/cleaner/more natural to put the directory examples/

inside the directory doc/.

Is this really a good idea?  If so, let's do it!

Related issues:

Related to CoCoALib - Support #574: Tidy CoCoA root directory Closed 19 Jun 2014

Related to CoCoALib - Support #1058: CoCoALib version in Documentation and Ex... Closed 04 May 2017

History

#1 - 16 Nov 2017 15:24 - John Abbott

- Category set to Documentation

- Status changed from New to In Progress

- Target version set to CoCoALib-0.99600

- % Done changed from 0 to 10

Anna was concerned that "hiding" examples/ inside doc/ might make it less visible; but apart from that doubt she liked the suggestion.

Maybe we can move it immediately after the next (imminent) release, and then see if it works OK for us...

#2 - 16 Nov 2017 15:24 - John Abbott

- Related to Support #574: Tidy CoCoA root directory added

#3 - 16 Nov 2017 15:24 - John Abbott

- Related to Support #1058: CoCoALib version in Documentation and Examples added

#4 - 16 Nov 2017 16:32 - John Abbott

If we do move examples/ into doc/ then presumably this should also be the case for an installed version of CoCoALib;

currently examples/ is copied "beside" doc/

#5 - 17 Jan 2018 12:00 - Anna Maria Bigatti

- Related to Support #1148: Release CoCoA-5.2.4 added

#6 - 17 Jan 2018 12:00 - Anna Maria Bigatti

- Related to deleted (Support #1148: Release CoCoA-5.2.4)

#7 - 18 Apr 2018 18:01 - John Abbott

- % Done changed from 10 to 20
Anna now likes the idea.

It may also help solve nicely a silly but annoying problem with the compilation of CopyInfo.C

(currently the Makefile in examples/ needs libcocoa.a to exist before compiling anything,

incl. CopyInfo)

#8 - 23 Apr 2018 11:18 - John Abbott

I have added a dirty hack to doc/Makefile so that CopyInfo can be compiled even when libcocoa.a does not exist

This hack works only if the attempt to compile CopyInfo comes from doc/Makefile; it does not work if

the attempt to compile comes from examples/Makefile.

This dirty hack must be removed when we move examples/ into doc/

#9 - 25 Jun 2018 15:29 - John Abbott

- Target version changed from CoCoALib-0.99600 to CoCoALib-0.99650 November 2019

#10 - 26 Jun 2018 11:51 - John Abbott

One problem is that the Makefile in the examples/ directory states explicitly that all executables depend on CoCoALib; this is very handy when

developing prototypes etc.

The problem is that CopyInfo should not depend on CoCoALib.  So an (ugly?) workaround would be to change the name of the source file to

CopyInfo.cpp; this would not then trigger the automatic dependency.  Any name will work provided it does not end in .C

#11 - 02 Aug 2018 13:14 - Anna Maria Bigatti

- Subject changed from Move examples directory into doc to Move examples directory into doc -- or just change makefile?

- Status changed from In Progress to Feedback

- Assignee set to Anna Maria Bigatti

- Target version changed from CoCoALib-0.99650 November 2019 to CoCoALib-0.99600

- % Done changed from 20 to 90

- Estimated time set to 5.01 h

After a long design discussion, John Abbott and I decided to try, as a first step, to separate from the examples makefile the makefile for making the

documentation.

I've implemented and tested it:

It is in Makefile-indexhtml, and is called by Makefile.

In practice it is used in the same way (make index.html, ...) but CopyInfo.C no longer has the dependency on libcocoa.a, which is necessary for all

example C files.

It makes the index of any ex-***.C file in the example directory, and this might actually turn out useful.

#12 - 03 Aug 2018 17:04 - John Abbott

- Status changed from Feedback to Closed
- % Done changed from 90 to 100

SUMMARY: we leave examples/ directory where it is (as it is more visible to the user), and have created a special Makefile for compiling

CopyInfo

The "new Makefile" solution is better than the previous arrangement.  Time will tell if it is good enough.

Closing.
